> ## Documentation Index
> Fetch the complete documentation index at: https://openwearables.io/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Timeseries

> Returns granular time series data (biometrics or activity).



## OpenAPI

````yaml https://api.openwearables.io/openapi.json get /api/v1/users/{user_id}/timeseries
openapi: 3.1.0
info:
  title: Open Wearables API
  version: 0.1.0
servers: []
security: []
paths:
  /api/v1/users/{user_id}/timeseries:
    get:
      tags:
        - 'External: Timeseries'
      summary: Get Timeseries
      description: Returns granular time series data (biometrics or activity).
      operationId: get_timeseries_api_v1_users__user_id__timeseries_get
      parameters:
        - name: user_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
            title: User Id
        - name: start_time
          in: query
          required: true
          schema:
            type: string
            description: >-
              ISO 8601 datetime (e.g. `2023-11-07T05:31:56Z`) or Unix timestamp
              in seconds. Date-only strings (e.g. `2023-11-07`) are also
              accepted and normalized to midnight UTC.
            examples:
              - '2023-11-07T05:31:56Z'
              - '2023-11-07'
            format: date-time
            title: Start Time
          description: >-
            ISO 8601 datetime (e.g. `2023-11-07T05:31:56Z`) or Unix timestamp in
            seconds. Date-only strings (e.g. `2023-11-07`) are also accepted and
            normalized to midnight UTC.
        - name: end_time
          in: query
          required: true
          schema:
            type: string
            description: >-
              ISO 8601 datetime (e.g. `2023-11-07T05:31:56Z`) or Unix timestamp
              in seconds. Date-only strings (e.g. `2023-11-07`) are also
              accepted and normalized to midnight UTC.
            examples:
              - '2023-11-07T05:31:56Z'
              - '2023-11-07'
            format: date-time
            title: End Time
          description: >-
            ISO 8601 datetime (e.g. `2023-11-07T05:31:56Z`) or Unix timestamp in
            seconds. Date-only strings (e.g. `2023-11-07`) are also accepted and
            normalized to midnight UTC.
        - name: types
          in: query
          required: false
          schema:
            type: array
            items:
              $ref: '#/components/schemas/SeriesType'
            default: []
            title: Types
        - name: resolution
          in: query
          required: false
          schema:
            enum:
              - raw
              - 1min
              - 5min
              - 15min
              - 1hour
            type: string
            default: raw
            title: Resolution
        - name: cursor
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Cursor
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            maximum: 100
            minimum: 1
            default: 50
            title: Limit
        - name: X-Open-Wearables-API-Key
          in: header
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: X-Open-Wearables-Api-Key
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedResponse_TimeSeriesSample_'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - OAuth2PasswordBearer: []
components:
  schemas:
    SeriesType:
      type: string
      enum:
        - heart_rate
        - resting_heart_rate
        - heart_rate_variability_sdnn
        - heart_rate_recovery_one_minute
        - walking_heart_rate_average
        - heart_rate_variability_rmssd
        - oxygen_saturation
        - blood_glucose
        - blood_pressure_systolic
        - blood_pressure_diastolic
        - respiratory_rate
        - sleeping_breathing_disturbances
        - breathing_disturbance_index
        - blood_alcohol_content
        - peripheral_perfusion_index
        - forced_vital_capacity
        - forced_expiratory_volume_1
        - peak_expiratory_flow_rate
        - height
        - weight
        - body_fat_percentage
        - body_mass_index
        - lean_body_mass
        - body_temperature
        - skin_temperature
        - skin_temperature_deviation
        - skin_temperature_trend_deviation
        - waist_circumference
        - body_fat_mass
        - skeletal_muscle_mass
        - vo2_max
        - six_minute_walk_test_distance
        - cardiovascular_age
        - steps
        - energy
        - basal_energy
        - stand_time
        - exercise_time
        - physical_effort
        - flights_climbed
        - average_met
        - active_time
        - distance_walking_running
        - distance_cycling
        - distance_swimming
        - distance_downhill_snow_sports
        - distance_other
        - walking_step_length
        - walking_speed
        - walking_double_support_percentage
        - walking_asymmetry_percentage
        - walking_steadiness
        - stair_descent_speed
        - stair_ascent_speed
        - running_power
        - running_speed
        - running_vertical_oscillation
        - running_ground_contact_time
        - running_stride_length
        - running_vertical_ratio
        - running_stance_time_balance
        - swimming_stroke_count
        - underwater_depth
        - cadence
        - power
        - speed
        - workout_effort_score
        - estimated_workout_effort_score
        - environmental_audio_exposure
        - headphone_audio_exposure
        - environmental_sound_reduction
        - time_in_daylight
        - water_temperature
        - uv_exposure
        - inhaler_usage
        - weather_temperature
        - weather_humidity
        - elevation
        - latitude
        - longitude
        - air_temperature
        - garmin_stress_level
        - garmin_skin_temperature
        - garmin_fitness_age
        - garmin_body_battery
        - electrodermal_activity
        - push_count
        - atrial_fibrillation_burden
        - insulin_delivery
        - number_of_times_fallen
        - number_of_alcoholic_beverages
        - nike_fuel
        - hydration
      title: SeriesType
      description: All supported time-series metric types.
    PaginatedResponse_TimeSeriesSample_:
      properties:
        data:
          items:
            $ref: '#/components/schemas/TimeSeriesSample'
          type: array
          title: Data
        pagination:
          $ref: '#/components/schemas/Pagination'
        metadata:
          $ref: '#/components/schemas/TimeseriesMetadata'
      type: object
      required:
        - data
        - pagination
        - metadata
      title: PaginatedResponse[TimeSeriesSample]
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    TimeSeriesSample:
      properties:
        timestamp:
          type: string
          format: date-time
          title: Timestamp
        zone_offset:
          anyOf:
            - type: string
              maxLength: 10
              pattern: ^[+-]\d{2}:\d{2}$
            - type: 'null'
          title: Zone Offset
          description: Timezone offset in the format '+01:00' or '-05:30'
          examples:
            - '+01:00'
            - '-05:30'
        type:
          $ref: '#/components/schemas/SeriesType'
        value:
          anyOf:
            - type: number
            - type: integer
          title: Value
        unit:
          type: string
          title: Unit
        source:
          anyOf:
            - $ref: '#/components/schemas/SourceMetadata'
            - type: 'null'
        is_daily_total:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Is Daily Total
      type: object
      required:
        - timestamp
        - type
        - value
        - unit
      title: TimeSeriesSample
    Pagination:
      properties:
        next_cursor:
          anyOf:
            - type: string
            - type: 'null'
          title: Next Cursor
          description: Cursor to fetch next page, null if no more data
          example: eyJpZCI6IjEyMzQ1Njc4OTAiLCJ0cyI6MTcwNDA2NzIwMH0
        previous_cursor:
          anyOf:
            - type: string
            - type: 'null'
          title: Previous Cursor
          description: Cursor to fetch previous page
        has_more:
          type: boolean
          title: Has More
          description: Whether more data is available
        total_count:
          anyOf:
            - type: integer
            - type: 'null'
          title: Total Count
          description: Total number of records matching the query
          example: 150
      type: object
      required:
        - has_more
      title: Pagination
    TimeseriesMetadata:
      properties:
        resolution:
          anyOf:
            - type: string
              enum:
                - raw
                - 1min
                - 5min
                - 15min
                - 1hour
            - type: 'null'
          title: Resolution
        sample_count:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sample Count
        start_time:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Start Time
        end_time:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Time
      type: object
      title: TimeseriesMetadata
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    SourceMetadata:
      properties:
        provider:
          type: string
          title: Provider
          example: apple_health
        device:
          anyOf:
            - type: string
            - type: 'null'
          title: Device
          example: Apple Watch Series 9
      type: object
      required:
        - provider
      title: SourceMetadata
  securitySchemes:
    OAuth2PasswordBearer:
      type: oauth2
      flows:
        password:
          scopes: {}
          tokenUrl: /api/v1/auth/login

````